
%global meadversion 7.2.1
%global namedversion 7.2.1.Final-redhat-10
%global meadalpha .Final_redhat_10
%global meadrel .1
%global serial 5

%global fullreltag %{meadalpha}
%global prodversion 6.1

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without mead

%define base_name jbossas
# jbhomedir is /usr/share/jbossas  (files must be immutable)
%define jbhomedir %{_datadir}/%{base_name}
# jbossdir is /var/lib/jbossas  (any mutable file like logs must go here)
%define jbossdir %{_localstatedir}/lib/%{base_name}
# jbosslogdir is /var/log/jbossas  (any logs must go here)
%define jbosslogdir %{_localstatedir}/log/%{base_name}
# jbdomainlogdir is /var/log/jbossas/domain  (any domain logs must go here)
%define jbdomainlogdir %{jbosslogdir}/domain
# jbossdatadir is /var/tmp/jbossas
# (Temporary files preserved between system reboots)
%define jbossdatadir %{_localstatedir}/tmp/%{base_name}
# jbdomaindatadir is /var/tmp/jbossas/domain
%define jbdomaindatadir %{jbossdatadir}/domain
# jbosstmpdir is /var/cache/jbossas (Application cache data)
%define jbosstmpdir %{_localstatedir}/cache/%{base_name}
# jbdomaintmpdir is /var/cache/jbossas/domain
%define jbdomaintmpdir %{jbosstmpdir}/domain

%define maven_version 7.2.1-4.Final_redhat_10.1.ep6.el6

Name: jbossas-domain
Epoch:		  0
Version: %{meadversion}
Release: %{serial}%{meadalpha}%{meadrel}%{?dist}
Summary: EAP 6 AS Domain Configuration
License: OpenSource
URL:              https://github.com/jbossas/jboss-as
Group: Development/Libraries

%if %with mead
Source102: jbossas-domain-7.2.1.Final-redhat-10.zip
Source103: jbossas-domain-7.2.1.Final-redhat-10.pom
%endif


# These should be in sync with the ones in jbossas-standalone
Source1:        jbossas.conf
Source2:        jbossas.init
# Change the domain file layout to "by-type"
Patch0:         jbossas-domain-by-type.patch
Patch1:         jbossas-domain-no-jar-index.patch

Provides: jbossas-configuration = %{epoch}:%{version}-%{release}

BuildRequires:    jpackage-utils

Requires:         jpackage-utils
Requires:         java
Requires:         jbossas-core

BuildArch:        noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
EAP AS 6 Domain Configuration.

%prep
unzip %{_sourcedir}/%{name}-%{namedversion}.zip \
      jboss-eap-%{prodversion}/bin/domain.sh \
      jboss-eap-%{prodversion}/bin/domain.conf \
      jboss-eap-%{prodversion}/domain/*

# Change the domain file layout to "by-type"
pushd jboss-eap-%{prodversion}/domain/configuration
%patch0 -p0
popd

%build
                                                                                                     
%install
pushd jboss-eap-%{prodversion}

# Create directories
# Variable files go there
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/domain
# Config files go there
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}/domain
# Directory for immutable files
# Links to variable file and config file locations make it appear
# like a full JBOSS_HOME tree
install -d -m 755 $RPM_BUILD_ROOT%{jbhomedir}
# Log dir for domain /var/log/jbossas/domain
install -d -m 755 $RPM_BUILD_ROOT%{jbdomainlogdir}
# The one below is for where files preserved between system reboots go
install -d -m 755 $RPM_BUILD_ROOT%{jbdomaindatadir}
install -d -m 755 $RPM_BUILD_ROOT%{jbdomaindatadir}/content
# The one below is for where Application cache data go
install -d -m 755 $RPM_BUILD_ROOT%{jbdomaintmpdir}
install -d -m 755 $RPM_BUILD_ROOT%{jbdomaintmpdir}/auth

# Symlink to re-create a JBOSS_HOME
%{__ln_s} %{jbossdir}/domain $RPM_BUILD_ROOT%{jbhomedir}/domain
# The one below is $RPM_BUILD_ROOT%{jbhomedir}/domain/configuration
%{__ln_s} %{_sysconfdir}/%{base_name}/domain \
          $RPM_BUILD_ROOT%{jbossdir}/domain/configuration
# The one below is for where log files go
# /var/lib/jbossas/domain/log  --> /var/log/jbossas/domain
%{__ln_s} %{jbdomainlogdir} $RPM_BUILD_ROOT%{jbossdir}/domain/log
# The one below is for where files preserved between system reboots go
# /var/lib/jbossas/domain/data  --> /var/tmp/jbossas/domain
%{__ln_s} %{jbdomaindatadir} $RPM_BUILD_ROOT%{jbossdir}/domain/data
# The one below is for where Application cache data go (for host-controller)
# /var/lib/jbossas/domain/tmp  --> /var/cache/jbossas/domain
%{__ln_s} %{jbdomaintmpdir} $RPM_BUILD_ROOT%{jbossdir}/domain/tmp


# Now install files

# bin dir scripts
install -d -m 755 $RPM_BUILD_ROOT%{jbhomedir}/bin
%{__cp} -pr bin/* $RPM_BUILD_ROOT%{jbhomedir}/bin
pushd $RPM_BUILD_ROOT%{jbhomedir}/bin
   %{__patch} -p0 < %{PATCH1}
popd

# Example config
%{__cp} -pr domain/configuration/* \
            $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}/domain

# Service-specific configuration file
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
cat > jbossas-domain << EOT
# Service-specific configuration file for jbossas services
# This will be sourced by the SysV service script after the global
# configuration file /etc/jbossas/jbossas.conf, thus allowing values
# to be overridden on a per-service way
#
# NEVER change the init script itself:
# To change values for all services make your changes in
# /etc/jbossas/jbossas.conf
# To change values for a specific service, change it here
# To create a new service, create a link from /etc/init.d/<you new service> to
# /etc/init.d/jbossas (do not copy the init script) and make a copy of the
# /etc/sysconfig/jbossas file to /etc/sysconfig/<you new service> and change
# the property values so the two services won't conflict
# Register the new service in the system as usual (see chkconfig and similars)
#
# To change a setting, uncomment the line and set the value for what you want
# The values in the comments are the default values, shown here for convenience
#
EOT
cat %{SOURCE1} >> jbossas-domain
install -p -m 644 jbossas-domain $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/jbossas-domain
sed -i -e 's/JBOSSCONF="standalone"/JBOSSCONF="domain"/' $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/jbossas-domain

#init script
install -d -m 755 $RPM_BUILD_ROOT%{_initrddir}
install -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/jbossas-domain
sed -i -e 's/JBoss EAP Standalone/JBoss EAP Domain/g' -e 's/Provides: jbossas/Provides: jbossas-domain/' -e 's/Short-Description: start and stop jbossas/Short-Description: start and stop jbossas-domain/' -e 's/JBOSSCONF=${JBOSSCONF:-"standalone"}/JBOSSCONF=${JBOSSCONF:-"domain"}/' $RPM_BUILD_ROOT%{_initrddir}/jbossas-domain

popd
                                                                                                     
%pre
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{_localstatedir}/lib/jbossas -g jboss jboss 2>/dev/null || :

%post
# add jbossas-domain service
[ -x /sbin/chkconfig ] && /sbin/chkconfig --add jbossas-domain || :
if [ "$1" > 1 ]; then
# If we are updating, make sure the /var/cache/jbossas directory has the
# right permissions as requested in BZ#900891
chown jboss:jboss %{jbosstmpdir}
chmod 750  %{jbosstmpdir}
fi

%preun
if [ "$1" = 0 ]; then
  # stop and remove service on erase
  %{_initrddir}/jbossas-domain stop > /dev/null 2>&1 || :
  [ -x /sbin/chkconfig ] && /sbin/chkconfig --del jbossas-domain
fi

%clean
                                                                                                     
%files
# Permissions removed for JBPAPP-9593
%defattr(0644,jboss,jboss,0750)
# Variable files will go here
%dir %{jbossdir}
%dir %{jbossdir}/domain
%defattr(0644,jboss,jboss,0755)
# Log files will go here
%dir %{jbdomainlogdir}
%dir %{jbossdir}/domain/log
%dir %{jbossdir}/domain/tmp
%dir %{jbossdir}/domain/data
%dir %{jbdomaindatadir}
%dir %{jbdomaindatadir}/content
%dir %{jbdomaintmpdir}/auth
%dir %{jbdomaintmpdir}
# Scrips
%dir %{jbhomedir}
%dir %{jbhomedir}/bin
%attr(0755,jboss,jboss) %{jbhomedir}/bin/domain.sh
%{jbhomedir}/bin/domain.conf
# JBOSS_HOME symlinks
%dir %{jbhomedir}/domain
#%%dir %{jbhomedir}/domain/configuration
%dir %{jbossdir}/domain/configuration
#init script
%attr(0755,root,root) %{_initrddir}/jbossas-domain
#service specific config file
%config(noreplace) %{_sysconfdir}/sysconfig/jbossas-domain
# Config files will go here
# Permissions removed for JBPAPP-9593
# Note the %%defattr if you put anything past this line
%defattr(0644,jboss,jboss,0750)
%dir %{_sysconfdir}/%{base_name}
%dir %{_sysconfdir}/%{base_name}/domain
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/domain.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/logging.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/default-server-logging.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/host.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/host-master.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/host-slave.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/mgmt-users.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/application-roles.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/domain/application-users.properties


%changelog
* Wed Aug 21 2013 Permaine Cheung <pcheung@redhat.com> - 7.2.1-7.Final_redhat_10
- EAP 6.1.1 ER7

* Tue Aug 13 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-4.Final_redhat_8
- EAP 6.1.1 ER5

* Tue Jul 30 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-3.Final_redhat_5
- EAP 6.1.1 ER4

* Wed Jul 17 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-3.Final_redhat_4
- EAP 6.1.1 ER3

* Thu May 09 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-8.Final_redhat_8
- EAP 6.1.0 ER8

* Wed May 08 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-7.Final_redhat_7
- EAP 6.1.0 ER7

* Tue Apr 30 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-6.Final_redhat_6
- EAP 6.1.0 ER6

* Wed Apr 17 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-5.Final_redhat_5
- EAP 6.1.0 ER5

* Wed Apr 17 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-5.Final_redhat_5
- EAP 6.1.0 ER5

* Tue Apr 02 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-4.Final_redhat_4
- EAP 6.1.0 ER4

- Add fix for BZ#900891

* Tue Mar 19 2013 Permaine Cheung <pcheung@redhat.com> - 7.2.0-3.1.Final_redhat_3
- Add fix for BZ 920742

* Tue Mar 05 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-3.Final_redhat_3
- EAP 6.1.0 ER3

* Tue Mar 05 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-3.Final_redhat_2
- EAP 6.1.0 ER2

* Wed Jan 30 2013 Permaine Cheung <pcheung@redhat.com> - 7.1.3-5.Final_redhat_4
- Add init script fix for BZ 905673

* Thu Nov 22 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-4.Final_redhat_4
- EAP 6.0.1 ER4

* Thu Nov 22 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-4.Final_redhat_4
- EAP 6.0.1 ER4

* Wed Oct 24 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.2.Final_redhat_3
- Use %%defattr for dir perms (for JBPAPP-9593)

* Fri Oct 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.1.Final_redhat_3
- EAP 6.0.1 ER3

* Fri Oct 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.Final_redhat_3
- EAP 6.0.1 ER3

* Fri Oct 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.Final_redhat_3
- EAP 6.0.1 ER3

* Fri Sep 28 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.2.Final_redhat_2
- Use smaller ZIP as source

* Wed Sep 26 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.1.Final_redhat_2
  From: Permaine Cheung <pcheung@redhat.com>
- JBPAPP-9612 fix JBOSS_HOST_CONFIG option

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.Final_redhat_2.1
- Rebuild for MD5

* Mon Sep 17 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.Final_redhat_2
- EAP 6.0.1 ER2

* Mon Sep 17 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.Final_redhat_2
- EAP 6.0.1 ER2

* Fri Sep 14 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-1.1.Final_redhat_1
# Permissions removed for JBPAPP-9593

* Wed Sep 05 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-1.Final_redhat_1
- EAP 6.0.1 ER1

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-11.1.Final_redhat_1
- Rebuild of 6.0.0.GA unsigned

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-11.1.Final_redhat_1
- Rebuild of 6.0.0.GA unsigned

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-11.Final_redhat_1
- Rebuild of 6.0.0.GA unsigned

* Thu Jun 07 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.2-8.Final_redhat_1
- Init script fixes - JBPAPP-9301, 9302, 9303

* Tue May 29 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-7.Final_redhat_1
- CR1 build

* Thu May 24 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-6.1.Final_redhat_1
- ER9 build

* Wed May 16 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.2-6.Final_redhat_1
- Init script fixes - report success on stopping a stopped service, report
  success on starting on an already started service, check if process is
  running in status and stop even if pid does not exist, add loop for wait
  time in start if port is busy

* Tue May 15 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-5.Final_redhat_1
- ER8 build

* Thu May 10 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-1.Final
- Upgrade to 7.1.2.Final

*Thu Apr 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-7.Final
- Change the domain file layout to "by-type"

*Thu Apr 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-6.Final
- Rebuild with apache-commons-*-eap6 and some other packages rebuilt w/ fixes

* Tue Apr 17 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-5.Final
- Return 0 for starting of service if already running

* Tue Apr 17 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-4.Final
- Return 0 for stopping of service if not running

* Mon Apr 16 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-3.Final
- Fix return value of init script to be the same as the function returns

*Wed Apr 11 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-2.Final
- Rebuild with -eap6 and some other package fixes

* Tue Apr 03 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-1.Final_redhat_1.3
- Add data/content and tmp/auth dirs

* Tue Apr 03 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-1.Final_redhat_1.2
- Own jbdomaindatadir and jbdomaintmpdir

*Fri Mar 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-1.Final.1
- Upgrade to 7.1.1.Final+  (ER4.1)

* Thu Mar 15 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.0-1.Final_redhat_1.1
- New data dir, content moved to it

* Wed Mar 14 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.0-1.Final
- Upgrade to ER3

* Fri Feb 24 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.4
- Add init script and and sysconfig files
- Update pre, post, preun sections to work with init scripts and service
- Create and link log dir

* Tue Jan 24 2012 Fernando Nasser <fnasser@redhat.com> - 0:7.1.0-0.1.CR1.3
- Fix useradd

* Mon Jan 23 2012 Fernando Nasser <fnasser@redhat.com> - 0:7.1.0-0.1.CR1.2
- Add provides jbossas-configuration

* Mon Jan 23 2012 Fernando Nasser <fnasser@redhat.com> - 0:7.1.0-0.1.CR1.1
- Wrap MEAD build for EAP 6

